Edit

Items - Create SQL Database

Creates a SQL database in the specified workspace.
This API supports long running operations (LRO).

To create a SQL database with a public definition, refer to SQLDatabase definition article.

Permissions

The caller must have a contributor workspace role.

Required Delegated Scopes

SQLDatabase.ReadWrite.All or Item.ReadWrite.All

Limitations

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities Yes

Interface

POST https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/sqlDatabases

URI Parameters

Name In Required Type Description
workspaceId
path True

string (uuid)

The workspace ID.

Request Body

Name Required Type Description
displayName True

string

The SQL database display name. The display name must follow naming rules according to item type.

creationPayload SQLDatabaseCreationPayload:

The SQL database creation payload.

definition

SQLDatabaseDefinition

The SQL database definition.

description

string

The SQL database description. Maximum length is 256 characters.

folderId

string (uuid)

The folder ID. If not specified or null, the SQL database is created with the workspace as its folder.

sensitivityLabelSettings

SensitivityLabelSettings

The sensitivity label settings for the SQL database.

Responses

Name Type Description
201 Created

SQLDatabase

Successfully created

202 Accepted

Request accepted, SQL database provisioning in progress.

Headers

  • Location: string
  • x-ms-operation-id: string
  • Retry-After: integer
429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • InvalidItemType - Item type is invalid

  • ItemDisplayNameAlreadyInUse - Item display name is already used.

  • CorruptedPayload - The provided payload is corrupted.

  • WorkspaceItemsLimitExceeded - Workspace item limit exceeded.

Examples

Create a SQLDatabase example
Create a SQLDatabase with definition example
Create a SQLDatabase with payload example
Create a SQLDatabase with payload of restore deleted database example

Create a SQLDatabase example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/sqlDatabases

{
  "displayName": "SQLDatabase 1",
  "description": "A SQLDatabase description."
}

Sample response

{
  "displayName": "SQLDatabase 1",
  "description": "A SQLDatabase description.",
  "type": "SQLDatabase",
  "workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
  "id": "5b218778-e7a5-4d73-8187-f10824047715",
  "sensitivityLabel": {
    "id": "b7b4f4d9-3f0d-4b3e-8f3d-4f6d3f4f3f4f"
  }
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30

Create a SQLDatabase with definition example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/sqlDatabases

{
  "displayName": "SQLDatabase1",
  "description": "A SQLDatabase description.",
  "definition": {
    "parts": [
      {
        "path": "definition.dacpac",
        "payload": "ew0KICAibGFrZWhvdXNlSWQiOiAiYjliNWQzNmYtNDQ0NS00MDNiLWFjODctMDE2YjFjZDIwMjExIg0KfQ==",
        "payloadType": "InlineBase64"
      }
    ]
  }
}

Sample response

{
  "displayName": "SQLDatabase 1",
  "description": "A SQLDatabase description.",
  "type": "SQLDatabase",
  "workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
  "id": "5b218778-e7a5-4d73-8187-f10824047715",
  "sensitivityLabel": {
    "id": "b7b4f4d9-3f0d-4b3e-8f3d-4f6d3f4f3f4f"
  }
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30

Create a SQLDatabase with payload example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/sqlDatabases

{
  "displayName": "SQLDatabase1",
  "description": "A SQLDatabase description.",
  "creationPayload": {
    "creationMode": "Restore",
    "sourceDatabaseReference": {
      "referenceType": "ById",
      "itemId": "d96de2f4-7dd1-45ad-9ff6-37a2d6aa9861",
      "workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229"
    },
    "restorePointInTime": "2024-12-01T00:00:00.000Z"
  }
}

Sample response

{
  "displayName": "SQLDatabase 1",
  "description": "A SQLDatabase description.",
  "type": "SQLDatabase",
  "workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
  "id": "5b218778-e7a5-4d73-8187-f10824047715",
  "sensitivityLabel": {
    "id": "b7b4f4d9-3f0d-4b3e-8f3d-4f6d3f4f3f4f"
  }
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30

Create a SQLDatabase with payload of restore deleted database example

Sample request

POST https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/sqlDatabases

{
  "displayName": "SQLDatabase1",
  "description": "A SQLDatabase description.",
  "creationPayload": {
    "creationMode": "RestoreDeletedDatabase",
    "restorableDeletedDatabaseName": "deletedDatabaseName",
    "restorePointInTime": "2024-12-01T00:00:00.000Z"
  }
}

Sample response

{
  "displayName": "SQLDatabase1",
  "description": "A SQLDatabase description.",
  "type": "SQLDatabase",
  "workspaceId": "cfafbeb1-8037-4d0c-896e-a46fb27ff229",
  "id": "5b218778-e7a5-4d73-8187-f10824047715"
}
Location: https://api.fabric.microsoft.com/v1/operations/0acd697c-1550-43cd-b998-91bfbfbd47c6
x-ms-operation-id: 0acd697c-1550-43cd-b998-91bfbfbd47c6
Retry-After: 30

Definitions

Name Description
CreateSQLDatabaseRequest

Create SQL database request payload.

CreationMode

The creation mode of the creation payload. Additional CreationMode types may be added over time.

EntireTenantPrincipal

Represents a tenant principal

ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

GroupPrincipal

Represents a security group.

GroupType

The type of the group. Additional group types may be added over time.

ItemReferenceById

An item reference by ID object.

ItemReferenceType

The item reference type. Additional ItemReferenceType types may be added over time.

ItemTag

Represents a tag applied on an item.

ItemType

The type of the item. Additional item types may be added over time.

NewSQLDatabaseCreationPayload

Create a SQL database item creation payload with supported settings

PayloadType

The type of the definition part payload. Additional payload types may be added over time.

PrincipalType

The type of the principal. Additional principal types may be added over time.

RestoreDeletedDatabaseCreationPayload

Note

PITR from deleted databases is currently in Preview (learn more).

Creates a SQL database item by restoring from a restorable deleted database.

RestoreSQLDatabaseCreationPayload

Create a SQL database item creation payload with restoring from a source database

SensitivityLabel

Represents a sensitivity label applied to an item.

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time.

SensitivityLabelSettings

The sensitivity label settings.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

SQLDatabase

A SQL database object.

SQLDatabaseDefinition

The SQL database public definition object. Refer to this article for more details on the structure of the SQL database definition.

SQLDatabaseProperties

The SQL database properties.

SQLDatabasePublicDefinitionPart

SQL database definition part object.

UserDetails

User principal specific details. Applicable when the principal type is User.

UserPrincipal

Represents a Microsoft Entra user principal.

CreateSQLDatabaseRequest

Create SQL database request payload.

Name Type Description
creationPayload SQLDatabaseCreationPayload:

The SQL database creation payload.

definition

SQLDatabaseDefinition

The SQL database definition.

description

string

The SQL database description. Maximum length is 256 characters.

displayName

string

The SQL database display name. The display name must follow naming rules according to item type.

folderId

string (uuid)

The folder ID. If not specified or null, the SQL database is created with the workspace as its folder.

sensitivityLabelSettings

SensitivityLabelSettings

The sensitivity label settings for the SQL database.

CreationMode

The creation mode of the creation payload. Additional CreationMode types may be added over time.

Value Description
New

The default creation mode. The 'backupRetentionDays' and 'collation' properties are accepted in this mode.

Restore

The creation mode for restoring from a source database. The 'sourceDatabaseReference' and 'restorePointInTime' properties are required. No other properties are accepted.

RestoreDeletedDatabase

The creation mode for restoring from a restorable deleted database. The 'restorableDeletedDatabaseName' and 'restorePointInTime' properties are required. No other properties are accepted.

EntireTenantPrincipal

Represents a tenant principal

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

EntireTenant

The type of the principal. Additional principal types may be added over time.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

isRetriable

boolean

When true, the request can be retried. Use the Retry-After response header to determine the delay, if available.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

GroupDetails

Group specific details. Applicable when the principal type is Group.

Name Type Description
groupType

GroupType

The type of the group. Additional group types may be added over time.

GroupPrincipal

Represents a security group.

Name Type Description
displayName

string

The principal's display name.

groupDetails

GroupDetails

Group specific details. Applicable when the principal type is Group.

id

string (uuid)

The principal's ID.

type string:

Group

The type of the principal. Additional principal types may be added over time.

GroupType

The type of the group. Additional group types may be added over time.

Value Description
Unknown

Principal group type is unknown.

SecurityGroup

Principal is a security group.

DistributionList

Principal is a distribution list.

ItemReferenceById

An item reference by ID object.

Name Type Description
itemId

string (uuid)

The ID of the item.

referenceType string:

ById

The item reference type.

workspaceId

string (uuid)

The workspace ID of the item.

ItemReferenceType

The item reference type. Additional ItemReferenceType types may be added over time.

Value Description
ById

The item is referenced by its ID.

ByVariable

The item is referenced by a variable.

ItemTag

Represents a tag applied on an item.

Name Type Description
displayName

string

The name of the tag.

id

string (uuid)

The tag ID.

ItemType

The type of the item. Additional item types may be added over time.

Value Description
Dashboard

PowerBI dashboard.

Report

PowerBI report.

SemanticModel

PowerBI semantic model.

PaginatedReport

PowerBI paginated report.

Datamart

PowerBI datamart.

Lakehouse

A lakehouse.

Eventhouse

An eventhouse.

Environment

An environment.

KQLDatabase

A KQL database.

KQLQueryset

A KQL queryset.

KQLDashboard

A KQL dashboard.

DataPipeline

A data pipeline.

Notebook

A notebook.

SparkJobDefinition

A spark job definition.

MLExperiment

A machine learning experiment.

MLModel

A machine learning model.

Warehouse

A warehouse.

Eventstream

An eventstream.

SQLEndpoint

An SQL endpoint.

MirroredWarehouse

A mirrored warehouse.

MirroredDatabase

A mirrored database.

Reflex

A Reflex.

GraphQLApi

An API for GraphQL item.

MountedDataFactory

A MountedDataFactory.

SQLDatabase

A SQLDatabase.

CopyJob

A Copy job.

VariableLibrary

A VariableLibrary.

Dataflow

A Dataflow.

ApacheAirflowJob

An ApacheAirflowJob.

WarehouseSnapshot

A Warehouse snapshot.

DigitalTwinBuilder

A DigitalTwinBuilder.

DigitalTwinBuilderFlow

A Digital Twin Builder Flow.

MirroredAzureDatabricksCatalog

A mirrored azure databricks catalog.

Map

A Map.

AnomalyDetector

An Anomaly Detector.

UserDataFunction

A User Data Function.

GraphModel

A GraphModel.

GraphQuerySet

A Graph QuerySet.

SnowflakeDatabase

A Snowflake Database to store Iceberg tables created from Snowflake account.

OperationsAgent

A OperationsAgent.

CosmosDBDatabase

A Cosmos DB Database.

Ontology

An Ontology.

EventSchemaSet

An EventSchemaSet.

DataAgent

A DataAgent.

MirroredCatalog

A MirroredCatalog.

NewSQLDatabaseCreationPayload

Create a SQL database item creation payload with supported settings

Name Type Description
backupRetentionDays

integer (int32)

minimum: 1
maximum: 35

Set the backup retention period in days. The minimum is 1 days. The maximum is 35 days.

collation

string

Set the collation of the SQL database.

creationMode string:

New

The creation mode of the SQL database creation.

PayloadType

The type of the definition part payload. Additional payload types may be added over time.

Value Description
InlineBase64

Inline Base 64.

PrincipalType

The type of the principal. Additional principal types may be added over time.

Value Description
User

Principal is a Microsoft Entra user principal.

ServicePrincipal

Principal is a Microsoft Entra service principal.

Group

Principal is a security group.

ServicePrincipalProfile

Principal is a service principal profile.

EntireTenant

Principal represents all tenant users.

RestoreDeletedDatabaseCreationPayload

Note

PITR from deleted databases is currently in Preview (learn more).

Creates a SQL database item by restoring from a restorable deleted database.

Name Type Description
creationMode string:

RestoreDeletedDatabase

The creation mode of the SQL database creation.

restorableDeletedDatabaseName

string

Set the name for the restorable deleted database to be restored.

restorePointInTime

string (date-time)

Set the time to restore the source database in UTC, using the YYYY-MM-DDTHH:mm:ssZ format.

RestoreSQLDatabaseCreationPayload

Create a SQL database item creation payload with restoring from a source database

Name Type Description
creationMode string:

Restore

The creation mode of the SQL database creation.

restorePointInTime

string (date-time)

Set the time to restore the source database in UTC, using the YYYY-MM-DDTHH:mm:ssZ format.

sourceDatabaseReference

ItemReferenceById

Set the reference for the source database to be restored from.

SensitivityLabel

Represents a sensitivity label applied to an item.

Name Type Description
id

string (uuid)

The sensitivity label ID.

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label. The default value is ApplyOrFail. Additional types may be added over time.

Value Description
ApplyOrFail

Apply the sensitivity label or fail the operation if it cannot be applied.

Ignore

Ignore the sensitivity label if it cannot be applied and proceed with the operation without applying the label.

SensitivityLabelSettings

The sensitivity label settings.

Name Type Description
labelId

string (uuid)

The sensitivity label ID.

sensitivityLabelApplyStrategy

SensitivityLabelApplyStrategy

The strategy for applying the sensitivity label.

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

Name Type Description
aadAppId

string (uuid)

The service principal's Microsoft Entra AppId.

ServicePrincipalPrincipal

Represents a Microsoft Entra service principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalDetails

ServicePrincipalDetails

Service principal specific details. Applicable when the principal type is ServicePrincipal.

type string:

ServicePrincipal

The type of the principal. Additional principal types may be added over time.

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

Name Type Description
parentPrincipal Principal:

The service principal profile's parent principal.

ServicePrincipalProfilePrincipal

Represents a service principal profile.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

servicePrincipalProfileDetails

ServicePrincipalProfileDetails

Service principal profile details. Applicable when the principal type is ServicePrincipalProfile.

type string:

ServicePrincipalProfile

The type of the principal. Additional principal types may be added over time.

SQLDatabase

A SQL database object.

Name Type Description
defaultIdentity Principal:

The item's default identity.

description

string

The item description.

displayName

string

The item display name.

folderId

string (uuid)

The folder ID.

id

string (uuid)

The item ID.

properties

SQLDatabaseProperties

The SQLDatabase properties.

sensitivityLabel

SensitivityLabel

The item sensitivity label.

tags

ItemTag[]

List of applied tags.

type

ItemType

The item type.

workspaceId

string (uuid)

The workspace ID.

SQLDatabaseDefinition

The SQL database public definition object. Refer to this article for more details on the structure of the SQL database definition.

Name Type Description
format

string

The format of the SQL database definition. Supported format: dacpac and sqlproj. If no format is provided, dacpac is used.

parts

SQLDatabasePublicDefinitionPart[]

A list of definition parts.

SQLDatabaseProperties

The SQL database properties.

Name Type Description
backupRetentionDays

integer (int32)

The backup retention period in days.

collation

string

The collation of the SQL database.

connectionString

string

The connection string of the database.

databaseName

string

The database name.

earliestRestorePoint

string (date-time)

ISO 8601 timestamp for the earliest restore point of the database in UTC, using the YYYY-MM-DDTHH:mm:ssZ format.

latestRestorePoint

string (date-time)

ISO 8601 timestamp for the latest restore point of the database in UTC, using the YYYY-MM-DDTHH:mm:ssZ format.

serverFqdn

string

The server fully qualified domain name (FQDN).

SQLDatabasePublicDefinitionPart

SQL database definition part object.

Name Type Description
path

string

The SQL database public definition part path. Supported SQL database content extensions: .dacpac for dacpac format; .sqlproj, .sql for sqlproj format.

payload

string

The SQL database public definition part payload.

payloadType

PayloadType

The payload type.

UserDetails

User principal specific details. Applicable when the principal type is User.

Name Type Description
userPrincipalName

string

The user principal name.

UserPrincipal

Represents a Microsoft Entra user principal.

Name Type Description
displayName

string

The principal's display name.

id

string (uuid)

The principal's ID.

type string:

User

The type of the principal. Additional principal types may be added over time.

userDetails

UserDetails

User principal specific details. Applicable when the principal type is User.